﻿using System;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Telerik.Windows.Controls;
using System.Collections;
using System.IO;

namespace SilverlightApplication1
{
    public abstract class DataSourceViewModelBase : ViewModelBase
    {
        protected const string silverlightPath = "DataSources/{0}";
        protected const string wpfPath = "/Chart;component/DataSources/{0}";

        protected virtual void GetData(string fileName)
        {
            Uri dataURI = new Uri("http://localhost:6414/"+fileName);
            System.Net.WebClient dataRetriever = new System.Net.WebClient();
            dataRetriever.DownloadStringCompleted += DownloadStringCompleted;
            dataRetriever.DownloadStringAsync(dataURI);
        }

        protected abstract void GetDataCompleted(IEnumerable data);

        protected abstract IEnumerable ParseData(TextReader dataReader);

        private void DownloadStringCompleted(object sender, System.Net.DownloadStringCompletedEventArgs e)
        {
            StringReader dataReader = new StringReader(e.Result);
            GetDataCompleted(this.ParseData(dataReader));
        }
    }
}
