﻿using System;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.ComponentModel;
using Telerik.Windows.Data;
using System.Collections.Generic;
using Telerik.Windows.Controls.Charting;

namespace SilverlightApplication1
{
    public class SeriesProxy
    {
        public SeriesProxy()
        {
            SortDescriptors = new List<SortDescriptorProxy>();
            FilterDescriptors = new List<FilterDescriptorProxy>();
            ItemMappings = new List<ItemMapping>();
        }
        public string ChartAreaName { get; set; }
        public int CollectionIndex { get; set; }
        public string LegendLabel { get; set; }
        public List<SortDescriptorProxy> SortDescriptors { get; set; }
        public List<FilterDescriptorProxy> FilterDescriptors { get; set; }
        public GroupSetting GroupSettings { get; set; }
        public List<ItemMapping> ItemMappings { get; set; }
    
    }

    public class GroupSetting
    {
        public GroupSetting()
        {
            GroupDescriptors = new List<GroupDescriptorProxy>();
        }
        public bool ShouldCreateSeriesForLastGroup { get; set; }
        public bool ShouldFlattenSeries { get; set; }
        public string GroupFieldName { get; set; }
        public List<GroupDescriptorProxy> GroupDescriptors { get; set; }
    }

    public class GroupDescriptorProxy
    {
        public string Member { get; set; }
        public Type Type { get; set; }
    }

    public class SortDescriptorProxy
    {
        public string Member { get; set; }
        public ListSortDirection SortDirection { get; set; }
    }

    public class FilterDescriptorProxy
    {
        public string Member { get; set; }
        public Type Type { get; set; }
        public FilterOperator Operator { get; set; }
        public object Value { get; set; }
        public bool IsCaseSensitive { get; set; }
    }

}
